#include "UbidotsESPMQTT.h"
 
/****************************************
   Define Constants
 ****************************************/
#define TOKEN "BBUS-h1Bv2aSTctldc8BXe734szeRlExrYd" // Your Ubidots TOKEN
#define WIFINAME "SUPERONLINE_Wi-Fi_4DN2" //Your SSID
#define WIFIPASS "XRSdQbGPP27Z" // Your Wifi Pass
#define DEVICE_LABEL  "control"  // Put here your Ubidots device label
#define VARIABLE1  "fan1"  // Put here your Ubidots variable label
#define VARIABLE2  "fan2"  // Put here your Ubidots variable label
#define VARIABLE3  "pump"  // Put here your Ubidots variable label
#define VARIABLE4  "light"  // Put here your Ubidots variable label
 
int load1 = D1; 
int load2 = D2; 
int load3 = D3; 
int load4 = D4;
 
float value=0; // To store incoming value.

Ubidots client(TOKEN);
 
/****************************************
   Auxiliar Functions
 ****************************************/
 
// cast from an array of chars to float value.
float btof(byte * payload, unsigned int length) {
  char * demo = (char *) malloc(sizeof(char) * 10);
  for (int i = 0; i < length; i++) {
    demo[i] = payload[i];
  }
  float value = atof(demo);
  free(demo);
  return value;
}
 
// Callback to handle subscription
 
void callback(char* topic, byte* payload, unsigned int length) {
  value = btof(payload, length);

 
if (value == 0.00)
{
  Serial.println("fan1 turned off"); 
  digitalWrite(load1, LOW); 
  client.add("fan1",0);
 
}
 
if (value == 1.00)
{
  Serial.println("fan1 turned ON"); 
  digitalWrite(load1, HIGH); 
    client.add("fan1",1);
 
}
 
 
if (value == 2.00)
{
  Serial.println("fan2 turned off"); 
  digitalWrite(load2, LOW); 
  client.add("fan2",0);
}
 
if (value == 3.00)
{
  Serial.println("fan2 turned ON"); 
  digitalWrite(load2, HIGH); 
  client.add("fan2",1);
}
 
 
 
if (value == 4.00)
{
  Serial.println(" pump turned off"); 
  digitalWrite(load3, LOW); 
  client.add(" pump",0);
}
 
if (value == 5.00)
{
  Serial.println(" pump turned ON"); 
  digitalWrite(load3, HIGH); 
  client.add(" pump",1);
}
 
 
 
if (value == 6.00)
{
  Serial.println("light turned off"); 
  digitalWrite(load4, LOW); 
  client.add("l",0);
}
 
if (value == 7.00)
{
  Serial.println("light turned ON"); 
  digitalWrite(load4, HIGH); 
  client.add("light",1);
}
   
}
 
/****************************************
   Main Functions
 ****************************************/
 
void setup() {
  // put your setup code here, to run once:
  client.ubidotsSetBroker("industrial.api.ubidots.com"); // Sets the broker properly for the business account
  client.setDebug(true); // Pass a true or false bool value to activate debug messages
  Serial.begin(115200);
  client.wifiConnection(WIFINAME, WIFIPASS);
  client.begin(callback);
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE1); //Insert the dataSource and Variable's Labels
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE2); //Insert the dataSource and Variable's Labels
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE3); //Insert the dataSource and Variable's Labels
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE4); //Insert the dataSource and Variable's Labels
 
 pinMode(load1, OUTPUT); 
 pinMode(load2, OUTPUT); 
 pinMode(load3, OUTPUT); 
 pinMode(load4, OUTPUT); 
 
}
 
void loop() {
  // put your main code here, to run repeatedly:
  if (!client.connected()) {
    client.reconnect();
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE1); //Insert the dataSource and Variable's Labels
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE2); //Insert the dataSource and Variable's Labels
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE3); //Insert the dataSource and Variable's Labels
  client.ubidotsSubscribe(DEVICE_LABEL, VARIABLE4); //Insert the dataSource and Variable's Labels

  }

 client.loop();
delay(500);
}
